# pycrontab.py
# Class to handle crontabs.

import popen2

class PyCrontab:
	def __init__(self):
		self.crontab = []

	def readtab(self, user = None, stripbegin = None, stripend = None):
		# Ask crontab for the crontab.
		userstr = " "
		if user != None:
			userstr = " -u %s " % user

		command = popen2.Popen3("crontab%s-l" % userstr, True)
		error = command.childerr.read()
		data = command.fromchild.read()

		command.fromchild.close()
		command.childerr.close()
		command.tochild.close()

		if command.wait() != 0:
			# Some error occurred.
			print "Error getting crontab: %s" % error
	
		# Strip out bits of crontab given by the markers.
		result = data
		if stripbegin != None and stripend != None:
			try:
				begin = data.index(stripbegin)
				end   = data.index(stripend) + len(stripend)
			except ValueError:
				# Unable to find those markers...
				# TODO... something?
				print "Unable to find markers to strip out old entries."
			else:
				result  = data[0:begin]
				result += data[end:]

		# Now split up the result.
		self.crontab = result.strip().split('\n')
	
	def addrawline(self, line):
		# Add a raw line, ie, a comment into the crontab.
		self.crontab.append(line)

	def addentry(self, when, command):
		# Append a simple item onto the crontab.
		# when is a datetime object.
		cronline = "%d %d %d %d * %s" % (when.minute, when.hour,
						when.day, when.month, command)
		self.crontab.append(cronline)

	def writetab(self, user = None):
		# Write out the crontab.
		outdata = "\n".join(self.crontab)

		userstr = " "
		if user != None:
			userstr = " -u %s " % user

		command = popen2.Popen3("crontab%s-" % userstr, True)
		command.tochild.write(outdata)
		command.tochild.close()
		error = command.childerr.read()
		response = command.fromchild.read()

		command.fromchild.close()
		command.childerr.close()

		if command.wait() != 0:
			# Some error occurred.
			print "Error writing crontab: %s" % error

